package org.artifactory.repo.system.suppliers;

import lombok.extern.slf4j.Slf4j;
import org.artifactory.api.config.CentralConfigService;
import org.artifactory.descriptor.repo.LocalRepoDescriptor;
import org.artifactory.descriptor.repo.RepoType;

/**
 * @author Tomer Slutsky
 */
@Slf4j
public class BuildInfoRepo extends SystemRepoBase {

    public BuildInfoRepo(CentralConfigService centralConfigService) {
        super(centralConfigService);
    }

    @Override
    public LocalRepoDescriptor buildDescriptor(String repoKey) {
        LocalRepoDescriptor repo = new LocalRepoDescriptor();
        repo.setKey(repoKey);
        repo.setType(RepoType.BuildInfo);
        return repo;
    }

    /**
     * This is used since there is a use case where the repoKey is made dynamically and not provided
     */
    public LocalRepoDescriptor buildDescriptor() {
        LocalRepoDescriptor repo = new LocalRepoDescriptor();
        repo.setType(RepoType.BuildInfo);
        return repo;
    }
}
