package org.artifactory.core.api.ph.virtual.resolution;

import java.util.LinkedList;
import java.util.List;

/**
 * Used by the {@link org.artifactory.core.api.ph.virtual.VirtualRepoTraversal} to collect all the valid versions of
 * the given package.
 */
public class PackageMetadataVersionsList<T extends PackageMetadataRow> {

    private final List<T> versions;
    private final boolean isPriorities;

    public PackageMetadataVersionsList(boolean isPriorities) {
        versions = new LinkedList<>();
        this.isPriorities = isPriorities;
    }

    public List<T> getVersions() {
        return versions;
    }

    public boolean isPriorities() {
        return isPriorities;
    }
}
